<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>lib.handle.handle_str &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      <li>lib.handle.handle_str</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for lib.handle.handle_str</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Module to handle strings.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">Union</span><span class="p">,</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">List</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">string</span>
<span class="kn">from</span> <span class="nn">uncertainties</span> <span class="kn">import</span> <span class="n">ufloat</span>


<div class="viewcode-block" id="concatenate_str"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_str.concatenate_str">[docs]</a><span class="k">def</span> <span class="nf">concatenate_str</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="n">sep</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s1">&#39; &#39;</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Concatenate a list of strings, using ``sep`` as separator. Remove</span>
<span class="sd">    ``None`` values and convert possible non-string values (such as int, ...)</span>

<span class="sd">    Args:</span>
<span class="sd">        *args: strings or object that can be converted into strings, or \</span>
<span class="sd">            ``None``</span>
<span class="sd">        sep : Separator between strings</span>
<span class="sd">        default : what to return if no non-None arguments are given</span>

<span class="sd">    Returns:</span>
<span class="sd">        strings concatenated with the separator ``str``</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">list_str</span> <span class="o">=</span> <span class="p">[</span>
        <span class="nb">str</span><span class="p">(</span><span class="n">arg</span><span class="p">)</span> <span class="k">for</span> <span class="n">arg</span> <span class="ow">in</span> <span class="n">args</span>
        <span class="k">if</span> <span class="n">arg</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span>
    <span class="p">]</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">list_str</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">default</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">sep</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">list_str</span><span class="p">)</span></div>


<div class="viewcode-block" id="turn_into_latex_friendly"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_str.turn_into_latex_friendly">[docs]</a><span class="k">def</span> <span class="nf">turn_into_latex_friendly</span><span class="p">(</span><span class="n">string</span><span class="p">:</span> <span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">str</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Replace `_` by ``\\_`` in a ``string`` to avoid latex errors</span>
<span class="sd">    with matplotlib</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">string</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;_&#39;</span><span class="p">,</span> <span class="s1">&#39;</span><span class="se">\\</span><span class="s1">_&#39;</span><span class="p">)</span></div>


<div class="viewcode-block" id="MyFormatter"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_str.MyFormatter">[docs]</a><span class="k">class</span> <span class="nc">MyFormatter</span><span class="p">(</span><span class="n">string</span><span class="o">.</span><span class="n">Formatter</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Class used for formatting not all the arguments of a string.</span>
<span class="sd">    Taken from</span>
<span class="sd">    https://stackoverflow.com/questions/17215400/format-string-unused-named-arguments</span>


<span class="sd">    Examples:</span>
<span class="sd">        &gt;&gt;&gt; fmt=MyFormatter()</span>
<span class="sd">        &gt;&gt;&gt; fmt.format(&quot;{a}{b}&quot;, a=&quot;blabla&quot;)</span>
<span class="sd">        &#39;blabla{b}&#39;</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="s1">&#39;{{</span><span class="si">{0}</span><span class="s1">}}&#39;</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">default</span> <span class="o">=</span> <span class="n">default</span>

<div class="viewcode-block" id="MyFormatter.get_value"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_str.MyFormatter.get_value">[docs]</a>    <span class="k">def</span> <span class="nf">get_value</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">kwargs</span><span class="p">):</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">key</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
            <span class="k">return</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">key</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">default</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">key</span><span class="p">))</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">string</span><span class="o">.</span><span class="n">Formatter</span><span class="o">.</span><span class="n">get_value</span><span class="p">(</span><span class="n">key</span><span class="p">,</span> <span class="n">args</span><span class="p">,</span> <span class="n">kwargs</span><span class="p">)</span></div></div>


<span class="n">fmt</span> <span class="o">=</span> <span class="n">MyFormatter</span><span class="p">()</span>

<span class="c1">#: Associates a predefined style with the corresponding format</span>
<span class="n">DICT_FORMAT_STYLES</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s2">&quot;int&quot;</span><span class="p">:</span> <span class="s1">&#39;,&#39;</span><span class="p">,</span>
    <span class="s2">&quot;float&quot;</span><span class="p">:</span> <span class="s1">&#39;.2f&#39;</span><span class="p">,</span>
    <span class="s2">&quot;ufloat&quot;</span><span class="p">:</span> <span class="s1">&#39;.1u&#39;</span><span class="p">,</span>
    <span class="s2">&quot;ufloat_small&quot;</span><span class="p">:</span> <span class="s1">&#39;.2ue&#39;</span><span class="p">,</span>
<span class="p">}</span>


<div class="viewcode-block" id="numeral_into_str"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_str.numeral_into_str">[docs]</a><span class="k">def</span> <span class="nf">numeral_into_str</span><span class="p">(</span>
        <span class="n">variable</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="nb">float</span><span class="p">,</span> <span class="n">ufloat</span><span class="p">],</span>
        <span class="n">style</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">str</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Transform a number into a string with the style given by ``style``.</span>

<span class="sd">    Args:</span>
<span class="sd">        variable: numeral</span>
<span class="sd">        style: formatting style. If not given, tries to determine it</span>

<span class="sd">    Returns:</span>
<span class="sd">        variable in str, using the formatting style given by ``style``</span>

<span class="sd">    Notes:</span>
<span class="sd">        Style aliases are given by ``DICT_FORMAT_STYLES``</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># Try to determine style automatically</span>
    <span class="k">if</span> <span class="n">style</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">variable</span><span class="p">,</span> <span class="nb">int</span><span class="p">):</span>
            <span class="n">style</span> <span class="o">=</span> <span class="n">DICT_FORMAT_STYLES</span><span class="p">[</span><span class="s2">&quot;int&quot;</span><span class="p">],</span>
        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">variable</span><span class="p">,</span> <span class="nb">float</span><span class="p">):</span>
            <span class="n">style</span> <span class="o">=</span> <span class="n">DICT_FORMAT_STYLES</span><span class="p">[</span><span class="s2">&quot;float&quot;</span><span class="p">]</span>
        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">variable</span><span class="p">,</span> <span class="n">ufloat</span><span class="p">):</span>
            <span class="n">style</span> <span class="o">=</span> <span class="n">DICT_FORMAT_STYLES</span><span class="p">[</span><span class="s2">&quot;ufloat&quot;</span><span class="p">]</span>
    <span class="k">elif</span> <span class="n">style</span> <span class="ow">in</span> <span class="n">DICT_FORMAT_STYLES</span><span class="p">:</span>
        <span class="n">style</span> <span class="o">=</span> <span class="n">DICT_FORMAT_STYLES</span><span class="p">[</span><span class="n">style</span><span class="p">]</span>

    <span class="k">if</span> <span class="n">style</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">return</span> <span class="nb">str</span><span class="p">(</span><span class="n">variable</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="s2">&quot;{:.</span><span class="si">{style}</span><span class="s2">}&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">variable</span><span class="p">,</span> <span class="n">style</span><span class="o">=</span><span class="n">style</span><span class="p">)</span></div>


<div class="viewcode-block" id="ufloat_str_into_latex"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_str.ufloat_str_into_latex">[docs]</a><span class="k">def</span> <span class="nf">ufloat_str_into_latex</span><span class="p">(</span><span class="n">ufloat_str</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">with_dollar</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">str</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Turn a raw ufloat string into an ufloat string in latex format:</span>

<span class="sd">    * ``&#39;+/-&#39;`` turned into ``&#39;\\pm&#39;``</span>
<span class="sd">    * ``&#39;e...&#39;`` turned into ``&#39;\\times 10^{...}&#39;``</span>

<span class="sd">    Args:</span>
<span class="sd">        ufloat_string : output of :py:func`str` of a ufloat</span>
<span class="sd">        with_dollar : whether to put the string in between ``$`` signs</span>

<span class="sd">    Returns:</span>
<span class="sd">        ufloat in latex format</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">ufloat_latex</span> <span class="o">=</span> <span class="n">ufloat_str</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;+/-&#39;</span><span class="p">,</span> <span class="s1">&#39;</span><span class="se">\\</span><span class="s1">pm&#39;</span><span class="p">)</span>

    <span class="k">if</span> <span class="s1">&#39;e&#39;</span> <span class="ow">in</span> <span class="n">ufloat_latex</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">ufloat_latex</span><span class="o">.</span><span class="n">endswith</span><span class="p">(</span><span class="s1">&#39;)e0&#39;</span><span class="p">):</span>
            <span class="n">ufloat_latex</span> <span class="o">=</span> <span class="n">ufloat_latex</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;)e0&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;(&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">ufloat_latex</span> <span class="o">=</span> <span class="n">ufloat_latex</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;e&#39;</span><span class="p">,</span> <span class="s1">&#39;</span><span class="se">\\</span><span class="s1">times 10^{&#39;</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;}&#39;</span>
    <span class="k">if</span> <span class="n">with_dollar</span><span class="p">:</span>
        <span class="n">ufloat_latex</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;$</span><span class="si">{ufloat_latex}</span><span class="s2">$&quot;</span>
    <span class="k">return</span> <span class="n">ufloat_latex</span></div>


<div class="viewcode-block" id="ufloat_into_latex"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_str.ufloat_into_latex">[docs]</a><span class="k">def</span> <span class="nf">ufloat_into_latex</span><span class="p">(</span>
        <span class="n">ufloat_var</span><span class="p">:</span> <span class="n">ufloat</span><span class="p">,</span> <span class="n">style</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s2">&quot;ufloat&quot;</span><span class="p">,</span>
        <span class="n">with_dollar</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">str</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Turn an ufloat into a latex string</span>

<span class="sd">    Args:</span>
<span class="sd">        ufloat_var: ufloat variable</span>
<span class="sd">        style: formatting style (if we want 2 significative numbers for</span>
<span class="sd">            the error, etc.)</span>
<span class="sd">        with_dollar : whether to put the string in between `$` signs</span>

<span class="sd">    Returns:</span>
<span class="sd">        ufloat in latex format, without the ``$``.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">ufloat_str_into_latex</span><span class="p">(</span>
        <span class="n">numeral_into_str</span><span class="p">(</span><span class="n">ufloat_var</span><span class="p">,</span> <span class="n">style</span><span class="o">=</span><span class="n">style</span><span class="p">),</span>
        <span class="n">with_dollar</span><span class="o">=</span><span class="n">with_dollar</span>
    <span class="p">)</span></div>


<div class="viewcode-block" id="get_list_wildcards"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_str.get_list_wildcards">[docs]</a><span class="k">def</span> <span class="nf">get_list_wildcards</span><span class="p">(</span><span class="n">string</span><span class="p">:</span> <span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]:</span>
    <span class="sd">&quot;&quot;&quot; Find the &quot;wildcards&quot; of a string.</span>

<span class="sd">    Args:</span>
<span class="sd">        string: string with wildcards</span>

<span class="sd">    Returns:</span>
<span class="sd">        list of the wildcards (string inside curly brackets) of ``string``</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">re</span><span class="o">.</span><span class="n">findall</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;{(.*?)}&#39;</span><span class="p">,</span> <span class="n">string</span><span class="p">)</span></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>